#!/opt/anaconda1anaconda2anaconda3/bin/Rscript

#usage Rscript get_cut_matrix.R path_to_1bp_res_counts_file path_to_bed_file output_file_name

args <- commandArgs(trailingOnly = TRUE)

counts_file <- read.table(args[1], col.names=c("chr","start","end","name","score","strand","pos","count"),stringsAsFactors=F)
print("counts imported")
bed_file <- read.table(args[2], col.names=c("chr","start","end","name","score","strand"),stringsAsFactors=F)
print("bed imported")

results <- vector()
counts <- vector()
idx <- vector()

for(i in 1:length(bed_file$start)){
  idx <- which(counts_file$start==bed_file$start[i] & counts_file$chr==bed_file$chr[i] & counts_file$strand==bed_file$strand[i])
  counts <- counts_file$count[idx]
  if(bed_file$strand[i]=="+"){
    results <- rbind(results, counts)
  } else if(bed_file$strand[i]=="-"){
    results <- rbind(results, rev(counts))  
  } else {
    stop("Strand mistake")
  }   
}

write.table(results,args[3],sep="\t",quote=F,row.names=F,col.names=F)
