#!/bin/bash


#example:
#bash make_1bp_bam.sh initial_bam_file chrom_sizes_file

set -e
set -u

bam_file=$1
chrom_sizes=$2

echo -n "Converting bam to bed and processing bed..."
/opt/anaconda1anaconda2anaconda3/bin/bamToBed -i $bam_file > $bam_file.bed
gawk 'OFS="\t" {if($6=="+") print $1,$2,$2+1,$4,$5,$6}' $bam_file.bed > $bam_file.bed.part1
gawk 'OFS="\t" {if($6=="-") print $1,$3-1,$3,$4,$5,$6}' $bam_file.bed > $bam_file.bed.part2
cat $bam_file.bed.part1 $bam_file.bed.part2 | sort -k1,1 -k2,2n > $bam_file.1bp.bed
echo "Done!"

echo -n "Generating and sorting bam file..."
/opt/anaconda1anaconda2anaconda3/bin/bedToBam -i $bam_file.1bp.bed -g $chrom_sizes > $bam_file.1bp.bam
/opt/anaconda1anaconda2anaconda3/bin/samtools sort $bam_file.1bp.bam $bam_file.1bp.sorted
/opt/anaconda1anaconda2anaconda3/bin/samtools index $bam_file.1bp.sorted.bam
echo "Done!"

echo -n "Removing intermediate files..."
rm $bam_file.bed
rm $bam_file.bed.part1
rm $bam_file.bed.part2
rm $bam_file.1bp.bed
rm $bam_file.1bp.bam
echo "Done!"
